# 来自SICP，1996年第二版的致谢

> 译者： [https://sicp.comp.nus.edu.sg/chapters/124](https://sicp.comp.nus.edu.sg/chapters/124)

 <matter>我们要感谢帮助我们开发本书和课程的许多人。

我们的主题显然是 &lt;quote&gt;6.231的知识分子后代，&lt;/quote&gt;是关于编程语言学和lambda微积分的精彩主题，由Jack Wozencraft和Arthur Evans，Jr在1960年代末在MIT教授。

我们欠罗伯特·法诺（Robert Fano）很大的债务，他重组了麻省理工学院的电气工程和计算机科学入门课程，以强调工程设计的原理。 他带领我们开始从事这项事业，并撰写了本书的第一套主题注释。

我们尝试教授的大多数编程风格和美学都是与盖伊·刘易斯·斯蒂尔·小（Guy Lewis Steele Jr.）共同开发的，他与杰拉尔德·杰伊·萨斯曼（Gerald Jay Sussman）合作，共同开发了Scheme语言。 另外，David Turner，Peter Henderson，Dan Friedman，David Wise和Will Clinger教给我们本书中出现的许多函数编程社区技术。

乔尔·摩西（Joel Moses）教我们如何构造大型系统。 他在Macsyma符号计算系统方面的经验提供了一种见识，即人们应该避免控制的复杂性，而应专注于组织数据以反映所建模世界的真实结构。

马文·明斯基（Marvin Minsky）和西摩·帕尔特（Seymour Papert）形成了我们对编程及其在我们的知识生活中的地位的许多态度。 对他们来说，我们拥有这样的理解，即计算为探索想法提供了一种表达手段，否则这些想法将过于复杂而无法精确处理。 他们强调，学生编写和修改程序的能力提供了一种强大的媒介，使探索成为一种自然的活动。

我们也非常同意Alan Perlis的观点，即编程很有趣，我们最好小心支持编程的乐趣。 这种快乐的一部分源于对工作中的大师们的观察。 我们很幸运在Bill Gosper和Richard Greenblatt的脚下成为了学徒程序员。

很难确定为我们课程的发展做出过贡献的所有人。 我们感谢过去十五年来与我们合作的所有讲师，朗诵讲师和导师，并为我们的主题投入了很多额外的时间，尤其是Bill Siebert，Albert Meyer，Joe Stoy，Randy Davis，Louis Braida，Eric Grimson， Rod Brooks，Lynn Stein和Peter Szolovits。 我们要特别感谢现在在韦尔斯利的Franklyn Turbak的杰出教学贡献； 他在本科教学中的工作设定了我们都可以追求的标准。 我们感谢Jerry Saltzer和Jim Miller帮助我们解决了并发之谜，并感谢Peter Szolovits和David McAllester在第4章中对不确定性评估的贡献。

许多人已经付出了巨大的努力在其他大学展示这种材料。 我们密切合作的一些人是Technion的Jacob Katzenelson，加州大学欧文分校的Hardy Mayer，牛津大学的Joe Stoy，普渡大学的Elisha Sacks和挪威科技大学的Jan Komorowski。 我们为在其他大学，包括耶鲁大学的肯尼思·叶（Kenneth Yip），伯克利大学（University of California，Berkeley）的布莱恩·哈维（Brian Harvey）和康奈尔大学（Cornell）的丹·赫特洛赫（Dan Huttenlocher）等其他大学的改编而获得重大教学奖的同事感到非常自豪。

艾尔·莫耶（AlMoyé）安排我们向惠普的工程师讲授这些材料，并制作这些讲座的录像带。 我们要感谢才华横溢的讲师，特别是Jim Miller，Bill Siebert和Mike Eisenberg，他们设计了包含这些录像带的继续教育课程，并在世界各地的大学和行业中进行了授课。

其他国家/地区的许多教育工作者为翻译第一版做了很多工作。 Michel Briand，Pierre Chamard和AndréPic制作了法文版； Susanne Daniels-Herold制作了德文版； Fumio Motoyoshi制作了日文版。 我们不知道是谁制作了中文版，但我们很荣幸被选为未经授权的翻译的主题。

很难列举为我们用于教学目的的Scheme系统的开发做出过技术贡献的所有人员。 除了盖伊·斯蒂尔之外，主要的巫师还包括克里斯·汉森，乔·鲍比尔，吉姆·米勒，吉列尔莫·罗扎斯和斯蒂芬·亚当斯。 投入大量时间的其他人包括Richard Stallman，Alan Bawden，Kent Pitman，Jon Taft，Neil Mayle，John Lamping，Gwyn Osnos，Tracy Larrabee，George Carrette，Soma Chaudhuri，Bill Chiarchiaro，Steven Kirsch，Leigh Klotz，Wayne Noss， Todd Cass，Patrick O'Donnell，Kevin Theobald，Daniel Weise，Kenneth Sinclair，Anthony Courtemanche，Henry M.Wu，Andrew Berlin和Ruth Shyu。

除了MIT实施之外，我们还要感谢许多从事IEEE Scheme标准工作的人员，包括编辑R ![%5E4](img/72d61fd46711d939a735c65eb025cbd8.jpg) RS的William Clinger和Jonathan Rees，以及Chris Haynes，David Bartley，Chris Hanson和Jim Miller ，谁编写了IEEE标准。

Dan Friedman一直是Scheme社区的长期领导人。 社区的广泛工作超出了语言设计的范围，涵盖了重大的教育创新，例如Schemer's Inc.基于EdScheme的高中课程，以及Mike Eisenberg和Brian Harvey和Matthew Wright的精彩著作。

我们感谢为使这本书成为真实书籍做出贡献的人们的工作，尤其是麻省理工学院出版社的Terry Ehling，Larry Cohen和Paul Bethge。 Ella Mazel找到了出色的封面图片。 对于第二版，我们特别感谢Bernard和Ella Mazel为本书设计提供的帮助，并特别感谢![%5Crm%5CTeX](img/42665c82db286885193cba491f8fbafd.jpg)向导奇才David Jones。 我们还要感谢那些对新草案发表了深刻评论的读者：Jacob Katzenelson，Hardy Mayer，Jim Miller，尤其是Brian Julvey，就像Julie在他的书 _Simply Scheme_ 中所做的那样。

最后，我们要感谢多年来鼓励这项工作的组织的支持，包括Ira Goldstein和Joel Birnbaum所提供的惠普支持，以及Bob Kahn所提供的DARPA支持。

> Harold Abelson和Gerald Jay Sussman</matter>